/*

                                   _JNJ`                        
                               .JNMH`                           
                              JMMF`       `;.                   
                            .NMM)          `MN.                 
                            MMM)            (MML                
                           (MMM`             MMML               
                     M  I  D  N  I  G  H  T    C  o  D  E       
                           (NMMF             MHNH               
                            NMML            .MMM                
                             NMML          .NMH                 
                              4MMNL       .#F                   
                               `4HNNL_   `                      
                                   `"""`                        

                          Copyright (C) 2004-2007
       "Ian (Larry) Latter" <ian dot latter at midnightcode dot org>

    Midnight Code is a registered trademark of Ian Latter.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, and mirrored at the Midnight Code web
    site; as at version 2 of the License only.
  
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
    General Public License for more details.
  
    You should have received a copy of the GNU General Public License
    (version 2) along with this program; if not, write to the Free
    Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
    02111-1307 USA, or see http://midnightcode.org/gplv2.txt

*/

/* midnightcode-logo.c :: Midnight Code logo library			*/


#include <stdio.h>
#include <string.h>
#include <stdarg.h>
#include <stdlib.h>
#include <unistd.h>

#include "preferences.h"
#include "midnightcode-colour.h"
#include "midnightcode-logo.h"



char midnightcode_logo_ascii[26][22] = {
  "               _JNJ`", "                    ",
  "           .JNMH`   ", "                    ",
  "          JMMF`     ", "  `;.               ",
  "        .NMM)       ", "   `MN.             ",
  "        MMM)        ", "    (MML            ",
  "       (MMM`        ", "     MMML           ",
  " M  I  D  N  I  G  H", "  T    C  o  D  E   ",
  "       (NMMF        ", "     MHNH           ",
  "        NMML        ", "    .MMM            ",
  "         NMML       ", "   .NMH             ",
  "          4MMNL     ", "  .#F               ",
  "           `4HNNL_  ", " `                  ",
  "               `\"\"\"`", "                    "
};



int
midnightcode_logo_buffer(char ** buffer, int padding, int style) {
  char pad[81];
  char * buffer_p;
  int element;
  int buffer_size;
  int buffer_offset;


  buffer_size = 2048;
  buffer_offset = 0;
  buffer_p = malloc(buffer_size);
  if(buffer_p == NULL)
    return -1;
  memset(buffer_p, 0, buffer_size);

  memset(pad, 0, 81);
  if(padding < 1 || padding > 80) {
    padding = 20;
  }
  memset(pad, ' ', padding);
  *buffer = buffer_p;

  for(element=0; element<26; element++) {

    if((float)((float)element/(float)2) == (int)(element/2)) {
      snprintf((buffer_p + buffer_offset), (buffer_size - buffer_offset),
        "%s", pad);
       buffer_offset = strlen(buffer_p);
    }

    if(style != MIDNIGHTCODE_COLOUR_STYLE_ASCII) {
      if(element == 12 || element == 13) {
        snprintf((buffer_p + buffer_offset), (buffer_size - buffer_offset),
          MIDNIGHTCODE_COLOUR_WHITE);
         buffer_offset = strlen(buffer_p);
      } else {
        switch(style) {
          case MIDNIGHTCODE_COLOUR_STYLE_LURKING_DARKNESS:
            if((float)((float)element/(float)2) == (int)(element/2)) {
              snprintf((buffer_p + buffer_offset),
                (buffer_size - buffer_offset),
                MIDNIGHTCODE_COLOUR_DK_GREY);
              buffer_offset = strlen(buffer_p);
            } else {
              snprintf((buffer_p + buffer_offset),
                (buffer_size - buffer_offset),
                MIDNIGHTCODE_COLOUR_DK_GREY);
              buffer_offset = strlen(buffer_p);
            }
            break;

          case MIDNIGHTCODE_COLOUR_STYLE_GHOSTING_TV:
            if((float)((float)element/(float)2) == (int)(element/2)) {
              snprintf((buffer_p + buffer_offset),
                (buffer_size - buffer_offset),
                MIDNIGHTCODE_COLOUR_GREY);
              buffer_offset = strlen(buffer_p);
            } else {
              snprintf((buffer_p + buffer_offset),
                (buffer_size - buffer_offset),
                MIDNIGHTCODE_COLOUR_DK_GREY);
              buffer_offset = strlen(buffer_p);
            }
            break;

          case MIDNIGHTCODE_COLOUR_STYLE_BLOOD_MOON:
            if((float)((float)element/(float)2) == (int)(element/2)) {
              snprintf((buffer_p + buffer_offset),
                (buffer_size - buffer_offset),
                MIDNIGHTCODE_COLOUR_BT_RED);
              buffer_offset = strlen(buffer_p);
            } else {
              snprintf((buffer_p + buffer_offset),
                (buffer_size - buffer_offset),
                MIDNIGHTCODE_COLOUR_RED);
              buffer_offset = strlen(buffer_p);
            }
            break;

          case MIDNIGHTCODE_COLOUR_STYLE_SHARP_WINE:
            if((float)((float)element/(float)2) == (int)(element/2)) {
              snprintf((buffer_p + buffer_offset),
                (buffer_size - buffer_offset),
                MIDNIGHTCODE_COLOUR_RED);
              buffer_offset = strlen(buffer_p);
            } else {
              snprintf((buffer_p + buffer_offset),
                (buffer_size - buffer_offset),
                MIDNIGHTCODE_COLOUR_RED);
              buffer_offset = strlen(buffer_p);
            }
            break;
        }
      }
    }

    snprintf((buffer_p + buffer_offset), (buffer_size - buffer_offset),
      "%s", midnightcode_logo_ascii[element]);
    buffer_offset = strlen(buffer_p);

    if(style != MIDNIGHTCODE_COLOUR_STYLE_ASCII) {
      snprintf((buffer_p + buffer_offset), (buffer_size - buffer_offset),
        MIDNIGHTCODE_COLOUR_NORMAL);
      buffer_offset = strlen(buffer_p);
    }
    if((float)((float)element/(float)2) != (int)(element/2)) {
      snprintf((buffer_p + buffer_offset), (buffer_size - buffer_offset),
        "\n");
      buffer_offset = strlen(buffer_p);
    }

  }

  snprintf((buffer_p + buffer_offset), (buffer_size - buffer_offset), "\n");
  buffer_offset = strlen(buffer_p);

  buffer_p = realloc(buffer_p, buffer_offset);
  if(buffer_p == NULL) {
    *buffer = NULL;
    return -1;
  }
  *buffer = buffer_p;


  return buffer_offset;
}



void
midnightcode_logo(int padding, int style) {
  char *buffer;
  int buffer_size;


  buffer_size = midnightcode_logo_buffer(&buffer, padding, style);
  if(buffer == NULL)
    return;
  if(buffer_size <= 0) {
    if(buffer)
      free(buffer);
    return;
  }

  fprintf(stdout, "%s", buffer);
  fflush(stdout);
  free(buffer);


  return;
}

