/*

                                   _JNJ`                        
                               .JNMH`                           
                              JMMF`       `;.                   
                            .NMM)          `MN.                 
                            MMM)            (MML                
                           (MMM`             MMML               
                     M  I  D  N  I  G  H  T    C  o  D  E       
                           (NMMF             MHNH               
                            NMML            .MMM                
                             NMML          .NMH                 
                              4MMNL       .#F                   
                               `4HNNL_   `                      
                                   `"""`                        

                          Copyright (C) 2004-2007
       "Ian (Larry) Latter" <ian dot latter at midnightcode dot org>

    Midnight Code is a registered trademark of Ian Latter.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, and mirrored at the Midnight Code web
    site; as at version 2 of the License only.
  
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
    General Public License for more details.
  
    You should have received a copy of the GNU General Public License
    (version 2) along with this program; if not, write to the Free
    Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
    02111-1307 USA, or see http://midnightcode.org/gplv2.txt

*/


/* midnightcode-servo.h :: Midnight Code servo io library		*/


#ifndef __MIDNIGHTCODE_SERVO_H
#define __MIDNIGHTCODE_SERVO_H 1


#define MIDNIGHTCODE_SERVO_STRUCTURE "servo"

struct midnightcode_servo_element_t
{
  char device[64];
  char label[128];
  int position;
  midnightcode_list_entry(midnightcode_servo_element_t)
};

struct midnightcode_servo_device_t
{
  const char * device;
};

midnightcode_list_head(midnightcode_servo_head_t, midnightcode_servo_element_t)

int midnightcode_servo_flush(struct midnightcode_servo_element_t * servo);
int midnightcode_servo_move(struct midnightcode_servo_element_t * servo,
                     int position);
int midnightcode_servo_probe(struct midnightcode_servo_element_t * servo);
int midnightcode_servo_list(struct midnightcode_servo_head_t * elements);


#endif
